/*
 * SMBTest.java
 *
 * Created on 04 January 2007, 14:47
 *
 */

package org.apache.nutch.protocol.smb.test;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Properties;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import jcifs.smb.SmbException;
import jcifs.smb.SmbFile;

/**
 *
 * @author ANene T. Nene
 */
public class SMBTest {
    
    /** Creates a new instance of SMBTest */
    public SMBTest() {
    }
    
    public static String USAGE = "Usage: SMBTest smb.properties \"smb://\" SERVER \"/\" SHARE \"/\" (FILE OUTPUT_FILE|DIR)";

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws MalformedURLException, SmbException, FileNotFoundException, IOException {
   
        if (args.length < 2) {
            System.out.println(USAGE);
            System.exit(1);
        }
        Properties prop = new Properties();
        prop.load(new FileInputStream(args[0]));
        jcifs.Config.setProperties(prop);
//        URL url = new URL("smb://xxxxxxxx");
        SmbFile file = new SmbFile(args[1]);
        System.out.println("Does the file exist on the share: "+file.exists());
//        System.out.println("here is the protocol used: "+url.getProtocol());
//        System.out.println("here is the host used: "+url.getHost());
        if(file.isDirectory()){
            System.out.println("Here is the content of the directory");
            for (int i = 0; i < file.listFiles().length; i++){
                SmbFile f = file.listFiles()[i];
                System.out.println(file.getName());
            }
        }else if(file.isFile()){
                if (args.length != 3) {
                    System.err.println(USAGE);
                    System.exit(1);
                }
                System.out.println("Name " + file.getName() + ", length " + file.getContentLength());
                System.out.println("Saving to " + args[2] + "...");
                java.io.InputStream is = file.getInputStream();
                java.io.FileOutputStream fos = new java.io.FileOutputStream(args[2]);
                int numread;
                byte b[] = new byte[4096];
                do {
                    numread = is.read(b);
                    if (numread < 0) {
                        break;
                    }
                    fos.write(b, 0, numread);
                } while(true);
                is.close();
                fos.close();
                System.out.println("Done.");
            }
    }
    
}
